package com.gmh.entity;

import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.Pattern;

@Data
@Accessors(chain = true)
public class RowCellNum {

    private Integer rowNum;

    private Integer cellNum;

    @Pattern(regexp = "^[A-Za-z]{1,3}[0-9]{1,4}", message = "单元格位置格式不正确")
    private String cellRowStr;

}
